.INCLUDE CRASH82.INC

NUMCOLS = 24			; handy equate

xpos = APD_BUF
ypos = xpos+1
enemies = ypos+1
lives = enemies+1
scrolls = lives+1
axes = scrolls+1

map = axes+1			; 16*24+1 = 385 bytes
maplastline = map+360
enemy_temp_Y = map+385
enemy_temp_X = enemy_temp_Y + 1
enemy_array = enemy_temp_X + 1		; 768-399= approx 349 bytes is ArrayMAX
;format
; enemy X = 1st byte
; enemy Y = 2nd byte
; null terminated



.db "Rogue Runner v1.0 by HM",0
 
 JR incipio

YOU_DIED:
 ld a,(lives)
 dec a
 ret z
 ld (lives),a
 jr RestartLevel

incipio:
 ld hl,APD_BUF
 ld (hl),0
 ld de,APD_BUF+1
 ld bc,767
 ldir			; clear all of savescreen
 ld a,187
 ld (map+384),a
LevelDONE:
 ld a,(enemies)
 inc a
 ld (enemies),a
 ld a,(lives)
 inc a
 ld (lives),a

RestartLevel:
 call graph_clear
 ld hl,title
 ld de,GRAPH_MEM+1
 ld bc,338
 ldir

 ROM_CALL(DISP_GRAPH)

 ld hl,28*256+32
 ld (CURSOR_X),hl
 ld hl,intro_text1
 ROM_CALL(D_ZM_STR)

 ld hl,30*256
 ld (CURSOR_X),hl
 ld a,(lives)
 call disp8bits
 ld hl,game_text3
 ROM_CALL(D_ZM_STR)

 ld hl,57*256+10
 ld (CURSOR_X),hl
 ld hl,intro_text2
 ROM_CALL(D_ZM_STR)
 ld a,(axes)
 call disp8bits

 ld hl,57*256+54
 ld (CURSOR_X),hl
 ld hl,intro_text3
 ROM_CALL(D_ZM_STR)
 ld a,(scrolls)
 call disp8bits

 ld hl,0A05h
 ld (CURSOR_ROW),hl
 ld a,(enemies)
 ld l,a
 ld h,0
 ROM_CALL(D_HL_DECI)

 ld hl,0805h
 ld (CURSOR_ROW),hl
 ld hl,game_text2
 ROM_CALL(D_ZT_STR)

 CALL CR_KHAND                 ; Call uncrashable keyboard handler

 call RandLevel
 call fixBORDERS
 
 call graph_clear
 call displayMAP
 ROM_CALL(DISP_GRAPH)

 ld b,12
showALLofMAP:
 call delay
 djnz showALLofMAP

 call hideWALLS

 call graph_clear
 call displayMAP
 ROM_CALL(DISP_GRAPH)

 ld a,2
 ld (xpos),a
 ld a,8
 ld (ypos),a


 call loadENEMIES

main:
 call graph_clear

 call getrand
 cp 50
 call c,moveENEMIES

 call displayMAP

 ld a,(ypos)
 ld e,a
 ld a,(xpos)
 ld hl,rogue
 call sprite

 ROM_CALL(DISP_GRAPH)

 call delay

 ld a,(xpos)
 ld l,a
 ld h,0
 ld a,(ypos)
 or a
 jr z,noMultYVectorMAIN
 ld b,a
 ld e,NUMCOLS
 ld d,0
multiplyYvectorMAIN:
 add hl,de
 djnz multiplyYvectorMAIN

noMultYVectorMAIN:
 ld de,map
 add hl,de

 ld a,(hl)
 cp 4
 jp z,YOU_DIED


 LD A,$fe
 OUT ($01),A ; Port 1 Keypad
 NOP \ NOP \ NOP \ NOP     
 IN A,($01) ; Port 1 Keypad
 LD B,A
 LD A,$ff
 IN A,($01) ; Port 1 Keypad
 LD A,B
 LD A,$bf
 OUT ($01),A ; Port 1 Keypad
 IN A,($01) ; Port 1 Keypad
 OR $0f
 AND B

 bit 5,a
 jp z,Teleport

 bit 1,a
 jr z,youMOVEleft

 bit 0,a
 jr z,youMOVEdown

 bit 2,a
 jr z,youMOVEright

 bit 3,a
 jr z,youMOVEup

 bit 6,a
 jp nz,main
 ret

youMOVEleft:
 ld a,(xpos)
 or a
 jp z,main
 dec a
 ld (xpos),a

 call isSPACEvalid
 jp c,main

 ld hl,xpos
 inc (hl)

 jp main

youMOVEright:
 ld a,(xpos)
 cp 23
 jp z,LevelDONE
 inc a
 ld (xpos),a

 call isSPACEvalid
 jp c,main

 ld hl,xpos
 dec (hl)

 jp main

youMOVEup:
 ld a,(ypos)
 or a
 jp z,main
 dec a
 ld (ypos),a

 call isSPACEvalid
 jp c,main

 ld hl,ypos
 inc (hl)

 jp main

youMOVEdown:
 ld a,(ypos)
 cp 15
 jp z,main
 inc a
 ld (ypos),a

 call isSPACEvalid
 jp c,main

 ld hl,ypos
 dec (hl)

 jp main


Teleport:
 ld a,(scrolls)
 or a
 jp z,main
 dec a
 ld (scrolls),a

TelePORTstartover:
 call getrand
 and %11111
 cp 24
 jr nc,TelePORTstartover
 ld (xpos),a
 
 call getrand
 and %1111
 ld (ypos),a

 call isSPACEvalid
 jr nc,TelePORTstartover

 jp main

isSPACEvalid:
 ld a,(xpos)
 ld l,a
 ld h,0
 ld a,(ypos)
 or a
 jr z,noMultYVector
 ld b,a
 ld e,NUMCOLS
 ld d,0
multiplyYvector:
 add hl,de
 djnz multiplyYvector

noMultYVector:
 ld de,map
 add hl,de

 ld a,(hl)
 cp 1
 jr z,makeITvisible
 cp 2
 jr z,canWEknockITdown
 cp 7
 jr z,axeFOUND
 cp 6
 jr nz,spaceVALID

 ld a,(scrolls)			; its a scroll!!!
 inc a
 ld (scrolls),a 
 jr spaceVALID

axeFOUND:
 ld a,(axes)
 inc a
 ld (axes),a

spaceVALID:
 ld (hl),0
 scf				; carry flag is set if the space is valid
 ret

makeITvisible:
 ld (hl),2
 ei
 halt
 ret

canWEknockITdown:
 ld a,(axes)
 or a
 ret z
 dec a
 ld (axes),a
 
 push hl
 ld a,(ypos)
 ld e,a
 ld a,(xpos)
 ld hl,exit
 call sprite
 ROM_CALL(DISP_GRAPH)

 call delay
 pop hl
 jr spaceVALID


displayMAP:
 ld hl,map
 ld c,16
resetX_mapLOOP:

 ld b,24
DISPLAYmapLOOP:
 ld a,(hl)
 or a
 jr z,blankSQUARE		; 0 produces nothing

 push hl

  push bc
   ld b,a
   ld hl,sprites
   ld e,4
   ld d,0
getSPRITEloop:			; which sprite???
   add hl,de
   djnz getSPRITEloop

  pop bc				; restore values
  push bc

   ld a,16
   sub c
   ld e,a
   ld a,24
   sub b
   call sprite
  pop bc
 pop hl

blankSQUARE:
 inc hl

 djnz DISPLAYmapLOOP

 dec c
 jr nz,resetX_mapLOOP
 ret


RandLevel:
 ld hl,map+23			; offset, since we need a top wall
 ld c,0
randlevelLOOP:
 inc hl
 ld a,(hl)
 cp 187
 ret z
 ld (hl),c

 call getrand
 cp 2
 jr nc,putWALLorBLANK

 and %1
 jr z,putTeleport

 ld (hl),7
 jr randlevelLOOP

putTeleport:
 ld (hl),6
 jr randlevelLOOP

putWALLorBLANK:
 cp 190
 jr c,randlevelLOOP		; rewrite the last block (open/brick)

 call getrand
 ld c,0
 and %111
 cp 5
 jr c,randlevelLOOP

 ld c,2
 jr randlevelLOOP

hideWALLS:
 ld hl,map
hidewallLOOP:
 ld a,(hl)
 cp 187
 ret z
 cp 2
 jr nz,notAwall

 call getrand
 cp 33
 jr c,notAwall

 ld (hl),1
notAwall:
 inc hl
 jr hidewallLOOP


fixBORDERS:
 ld hl,map
 ld (hl),2
 ld de,map+1
 ld bc,24
 ldir

 ld hl,maplastline
 ld (hl),2
 ld de,maplastline+1
 ld bc,23
 ldir

 ld hl,map+47		; 23+ 24*1row
 ld b,14
 ld c,0
DRAWsidewalls:
 ld a,(hl)
 cp 5
 jr z,exitALREADYthere
 ld (hl),2
exitALREADYthere:
 inc hl
 ld (hl),2
 ld de,21
 add hl,de

 ld a,c
 cp 1
 jr z,thereHASbeenanEXIT

 ld a,(hl)
 inc hl
 cp 2
 jr z,skipEXITtest

 ld a,(hl)
 cp 2
 jr z,skipEXITtest
 inc hl
 ld (hl),5
 ld c,1
 dec hl

skipEXITtest:
 inc hl
 djnz DRAWsidewalls
 ret

thereHASbeenanEXIT:
 inc hl
 jr skipEXITtest


moveENEMIES:
 ld hl,enemy_array
 push hl
EnemyArrayLoopStart:
 pop hl
 
EnemyArrayLOOP:
 ld a,(hl)
 or a
 ret z
 ld (enemy_temp_X),a
 
 inc hl

 ld a,(hl)
 ld (enemy_temp_Y),a

 push hl

 call isENEMYvalid
 ld (hl),0			; we are moving!!!

 call getrand
 cp 64
 jr c,enMOVELEFT
 cp 128
 jr c,enMOVEUP
 cp 196
 jr c,enMOVEDOWN

 ld hl,enemy_temp_X
 inc (hl)
 jr EAloopEND

enMOVELEFT:
 ld hl,enemy_temp_X
 dec (hl)
 jr EAloopEND

enMOVEUP:
 ld hl,enemy_temp_Y
 inc (hl)
 jr EAloopEND

enMOVEDOWN:
 ld hl,enemy_temp_Y
 dec (hl)

EAloopEND:
 pop hl
 dec hl
 push hl
 call isENEMYvalid
 jr nc,EnemyArrayLoopStart

 ld (hl),4
 pop hl
 ld a,(enemy_temp_X)
 ld (hl),a
 inc hl
 ld a,(enemy_temp_Y)
 ld (hl),a
 inc hl 
 jp EnemyArrayLOOP




isENEMYvalid:
 ld a,(enemy_temp_X)
 ld l,a
 ld h,0
 ld a,(enemy_temp_Y)
 or a
 jr z,noMultYVectorEnemy
 ld b,a
 ld e,NUMCOLS
 ld d,0
multiplyYvectorEnemy:
 add hl,de
 djnz multiplyYvectorEnemy

noMultYVectorEnemy:
 ld de,map
 add hl,de

 ld a,(hl)
 cp 1
 ret z
 cp 2
 ret z

 scf				; carry flag is set if the space is valid
 ret

loadENEMIES:
 ld a,(enemies)
 ld b,a
 ld hl,enemy_array
LEloop:
 push bc
 push hl

LoadENEMIESstartover:
 call getrand
 and %11111
 cp 24
 jr nc,LoadENEMIESstartover
 ld (enemy_temp_X),a
 
 call getrand
 and %1111
 ld (enemy_temp_Y),a

 call isENEMYvalid
 jr nc,LoadENEMIESstartover

 pop hl

 ld a,(enemy_temp_X)
 ld (hl),a
 inc hl
 ld a,(enemy_temp_Y)
 ld (hl),a
 inc hl

 pop bc
 djnz LEloop
 ret


;++++++++++++++++++++
;+ Utility Routines +
;++++++++++++++++++++

graph_clear:
 ld hl,GRAPH_MEM
 ld de,GRAPH_MEM+1
 ld (hl),0
 ld bc,767
 ldir
 ret

disp8bits:
 ld b,0
HUNDplaceDISP8:
 cp 100
 jr c,TENSplaceDISP8

 sub 100
 inc b
 jr HUNDplaceDISP8

TENSplaceDISP8:
 push af
 ld a,b
 or a
 jr z,NOhundDISP8

 ld a,30h		; "0"
 add a,b
 ROM_CALL(M_CHARPUT)

NOhundDISP8:
 pop af
 ld b,0
TENSloopDISP8:
 cp 10
 jr c,ONESplaceDISP8

 sub 10
 inc b
 jr TENSloopDISP8

ONESplaceDISP8:
 push af
 ld a,b
 or a
 jr z,NOtensDISP8
 ld a,30h		; "0"
 add a,b
 ROM_CALL(M_CHARPUT)

NOtensDISP8:
 pop af
 ld b,30h		; "0"
 add a,b
 ROM_CALL(M_CHARPUT)
 ret 



delay:
 push bc
 ld b,10
 ei
delayLOP:
 halt
 djnz delayLOP
 pop bc
 ret

getrand:			; by jason todd
	ld a,(randseed)
	ld b,a
	ld a,r
	add a,b
	sla b
	sla b
	add a,b
	sla b	
	sla b
	add a,b
	add a,e
	inc a
	rrc a
	ld (randseed),a
	ret

randseed: .db %10101010

;*************************************
;* MODIFIED movax's routine for this
;*************************************
; displays 4x4 sprite on a 16x24 grid
;  a= x, e=y
;**********

sprite:
 push    hl             ; Save sprite address

 ld hl,0
 ld d,0
 add hl,de
 add hl,de		; y*2..
 add hl,de		; y*3...
 add hl,hl		; y*6
 add hl,hl		; y*12

 add hl,hl		; y*24
 add hl,hl		; y*48

 ld      e,a		; x/2
 srl     e
 add     hl,de

 ld      de,GRAPH_MEM
 add     hl,de          ; Add address to graphbuf


 and %1			; is it odd?
 jr z,ALIGN


;we can cheat since its always 4 off.

 pop de
 ld b,4
NOTALIGNED:
 ld a,(de)	; de->sprite location
 srl a
 srl a
 srl a
 srl a		; slide it over 4 bytes
 or (hl)
 ld (hl),a
 inc de
 push bc
 ld bc,12
 add hl,bc
 pop bc
 djnz NOTALIGNED
 ret

ALIGN:
 pop     de              ; de->sprite
 ld      b,4
ALOP1:
 ld      a,(de)
 or      (hl)            ; xor=erase/blit
 ld      (hl),a
 inc     de
 push    bc
 ld      bc,12
 add     hl,bc
 pop     bc
 djnz    ALOP1
 ret

;+++++++++++
;+ sprites +
;+++++++++++

sprites:
 .db 0,0,0,0

;1
 .db 0,0,0,0

;2
 .db %10100000
 .db %01010000
 .db %10100000
 .db %01010000

;3 - rogue
rogue:
 .db %01100000
 .db %10010000
 .db %10010000
 .db %01100000

;4 - enemy
 .db %10010000
 .db %01100000
 .db %01100000
 .db %10010000

;5 - exit
exit:
 .db %11110000
 .db %11110000
 .db %11110000
 .db %11110000

;6 - scroll
 .db %11110000
 .db %01100000
 .db %01100000
 .db %11110000

;7 - axe
 .db %01110000
 .db %00110000
 .db %01010000
 .db %10000000

;++++++++
;+ text +
;++++++++

intro_text1: .db "By: Harper Maddox",0
intro_text2: .db "Axes: ",0
intro_text3: .db "Scrolls: ",0

game_text0: .db "YOU",0
game_text1: .db "DIED!",0
game_text2: .db "Level",0
game_text3: .db "Live(s)",0


;++++++++
;+ data +
;++++++++

title:
    .db     31,15,0,0,0,0,0,0,0,0,0,0,17,49,0,0,0,0,0,0,0,0,0,0,39,201,1,255,1,248
    .db     15,225,0,39,255,0,42,2,131,255,131,252,31,241,128,111,255,0,65,80,131,255,199,254,63,241,192,239,254,7,212
    .db     10,131,255,239,255,127,225,225,239,252,5,65,64,131,193,239,15,120,1,225,239,0,5,255,191,179,193,239,15,120,1
    .db     225,239,0,5,127,255,171,193,239,15,120,1,225,239,0,6,0,222,235,193,239,15,120,1,225,239,0,15,191,0,107
    .db     193,239,15,120,1,225,239,0,53,215,165,59,255,238,7,123,225,192,239,254,101,147,136,91,255,232,1,103,249,0,47
    .db     255,74,79,33,27,255,204,3,115,253,128,111,255,235,244,8,91,255,143,15,121,253,225,239,252,127,249,247,251,199,207
    .db     15,120,61,225,239,0,75,231,190,19,199,207,15,120,61,225,239,0,97,128,0,35,195,207,15,120,61,225,239,0,36
    .db     70,0,83,195,239,15,120,61,225,239,0,23,167,15,163,193,239,255,127,253,255,239,248,26,62,112,35,193,255,255,63
    .db     253,255,239,252,10,93,128,67,128,115,254,31,248,127,207,254,13,219,0,131,0,51,252,15,224,127,143,255,3,4,0
    .db     128,0,0,0,0,0,0,0,0,3,216,0,129,255,255,255,255,255,255,255,254,4,112,0,128,255,255,255,255,255,255
    .db     255,252,6,32,0,128,0,0,0,0,0,0,0,0,1,32,0,64,15,255,255,255,255,255,255,192,1,160,32,64,0
    .db     0,0,0,0,0,0,0,127,255,247
